/**************** 
   stuff.c
   utility functions like min, max, sum, argmin, argmax, etc.
****************/

#include "stuff.h"

double dsum(double* x, int n, int step)
{
  int i;
  double s;
  s = 0;
  for(i=0;i<n;i++)
    s+=x[i*step];
  return s;
}

int isum(int* x, int n, int step)
{
  int i;
  int s;
  s = 0;
  for(i=0;i<n;i++)
    s+=x[i*step];
  return s;
}

double dmin(double* x, int n){
  double m;
  int i;
  
  m=x[0];
  for(i=0;i<n;i++)
    {
      if(x[i]<m){
	m = x[i];
      }
    }
  return m;
}

int imin(int* x, int n){
  int m;
  int i;
  
  m=x[0];
  for(i=0;i<n;i++)
    {
      if(x[i]<m){
	m = x[i];
      }
    }
  return m;
}

int dargmin(double* x, int n){
  double m;
  int i,j;
  m = x[0];
  j=0;
  for(i=0;i<n;i++)
    {
      if(x[i]<m)
	{
	  m = x[i];
	  j = i;
	}
    }
  return j;
}

int iargmin(int* x, int n){
  int m;
  int i,j;
  m = x[0];
  j=0;
  for(i=0;i<n;i++)
    {
      if(x[i]<m)
	{
	  m = x[i];
	  j = i;
	}
    }
  return j;
}

double dmax(double* x, int n){
  double m;
  int i;
  
  m=x[0];
  for(i=0;i<n;i++)
    {
      if(x[i]>m)
	{
	  m = x[i];
	}
    }
  return m;
}

int imax(int* x, int n){
  int m;
  int i;
  
  m=x[0];
  for(i=0;i<n;i++)
    {
      if(x[i]>m)
	{
	  m = x[i];
	}
    }
  return m;
}

int dargmax(double* x, int n){
  double m;
  int i,j;
  m = x[0];
  j=0;
  for(i=0;i<n;i++)
    {
      if(x[i]>m)
	{
	  m = x[i];
	  j = i;
	}
    }
  return j;
}

int iargmax(int* x, int n){
  int m;
  int i,j;
  m = x[0];
  j=0;
  for(i=0;i<n;i++)
    {
      if(x[i]>m)
	{
	  m = x[i];
	  j = i;
	}
    }
  return j;
}


